package bsp

import (
	"sync"

	"tuxpa.in/t/wm/src/bsp/cfg"
)

type WM struct {
	Desktops []*Desktop
	Monitors []*Monitor

	Cfg *cfg.Modifier[*Config]

	mu sync.RWMutex
}

type Desktop struct {
	Name    string
	Monitor *Monitor

	Cfg *cfg.Modifier[Config]
}

type Monitor struct {
	Name string

	Cfg *cfg.Modifier[Config]
}

type Node struct {
	Name string

	Cfg *cfg.Modifier[Config]
}

func (w *WM) Mutate(fn func() error) {
	w.mu.Lock()
	defer w.mu.Unlock()
	if fn != nil {
		fn()
	}
}

func (w *WM) View(fn func() error) {
	w.mu.RLock()
	defer w.mu.RUnlock()
	if fn != nil {
		fn()
	}
}

func (w *WM) AddDesktop(name string) {

}

func NewWM() *WM {
	w := &WM{
		Cfg: cfg.NewModifier(&Config{}),
	}
	w.Cfg.FillDefaults()

	return w
}
